static char *cvs_id =" $Id: xy_lib.c,v 1.1.1.1 2002/01/03 14:52:03 berar Exp $ ";
/*  xy_lib : lib for wv, gel and gel images   */
/*  jf berar                                  */
/*--------------------------------------------*/

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
/* need -Ae on HPUX not -Aa */
#include <sys/types.h> 
#include <sys/stat.h>
#include <time.h>
/*-----------------------------------------------------------*/
#include "prg_def.h"
#include "xy_def.h"
/*-----------------------------------------------------------*/
#ifdef __WIN32__
#ifndef __CONSOLE__
#error console mode expected under WIN32
#endif
#include <dos.h>
#define DEF_XY_WV
#define INC_XY_EDF
#define INC_XY_GEL
#define INC_XY_TXT
#endif
/*-----------------------------------------------------------*/
#ifdef __WIN32__
#define PATH_CHAR '\\'
#define PATH_STR  "\\"
#else
#define PATH_CHAR '/'
#define PATH_STR  "/"
#endif
/*-----------------------------------------------------------*/
#if (defined(DEF_XY_WV) || defined(INC_XY_WV))
#include "wv_def.h"        
#endif
#if (defined(DEF_XY_EDF) || defined(INC_XY_EDF))
#include "edf_def.h"        
#endif
#if (defined(DEF_XY_GEL) || defined(INC_XY_GEL))
#include "gel_def.h"        
#endif
#if (defined(DEF_XY_TXT) || defined(INC_XY_TXT))
#include "txt_def.h"        
#endif
#if (defined(DEF_XY_DMI) || defined(INC_XY_DMI))
#include "dmi_def.h"        
#endif
/*-----------------------------------------------------------*/
void (* xy_swap16) (INT16U * brut) = NULL;
void (* xy_swap32) (INT32 * brut)  = NULL;
int   xy_doswap = 1;
char *xy_swapstring = "swapping not yet defined";
/*-----------------------------------------------------------*/
void xy_chktype( void)
{   if (sizeof(INT16U) != 2 || sizeof(INT32) < 4 )
       V_ERROR(" INT16U or INT32 are not 16 or 32 bits integers! ");
    }
/*-----------------------------------------------------------*/
void     xy_iniuse (void)
{   fprintf(stderr, " Items used in the .ini file\n");
    fprintf(stderr, "  X_MIN = \n");
    fprintf(stderr, "  Y_MIN = \n");
    fprintf(stderr, "  X_MAX = \n");
    fprintf(stderr, "  Y_MAX = \n");
    fprintf(stderr, "  X_BIND = \n");
    fprintf(stderr, "  Y_BIND = \n");
    fprintf(stderr, "  BEG_FRAME = \n");
    fprintf(stderr, "  END_FRAME = \n");
    fprintf(stderr, "  MULT   = \n");
    }
/*-----------------------------------------------------------*/
int   xy_inipar ( IMAGE *img, char* tag, char *arg)
{   if (prg_iniint ( tag, arg, "X_MIN", &(img->x_omin))) return 1;
    if (prg_iniint ( tag, arg, "X_MAX", &(img->x_omax))) return 1;
    if (prg_iniint ( tag, arg, "Y_MIN", &(img->y_omin))) return 1;
    if (prg_iniint ( tag, arg, "Y_MAX", &(img->y_omax))) return 1;
    if (prg_iniint ( tag, arg, "X_BIND", &(img->x_obind))) return 1;
    if (prg_iniint ( tag, arg, "Y_BIND", &(img->y_obind))) return 1;
    if (prg_iniflt ( tag, arg, "MULT", &(img->mult))) return 1;
    if (prg_iniint ( tag, arg, "BEG_FRAME", &(img->beg_frame))) return 1;
    if (prg_iniint ( tag, arg, "END_FRAME", &(img->end_frame))) return 1;
    }
/*-----------------------------------------------------------*/
void xy_setsize( IMAGE *img)
{   img->x_osize = img->header->x_dim;
    img->y_osize = img->header->y_dim;
    img->osize = img->x_osize * img->y_osize;
    if ( img->x_obind <= 0 ) img->x_obind = 1;
    if ( img->y_obind <= 0 ) img->y_obind = 1;
    if ( img->x_omax == 0 ) img->x_omax = img->x_osize;
    if ( img->y_omax == 0 ) img->y_omax = img->y_osize;
    if ( img->x_omax > img->x_osize ) img->x_omax = img->x_osize;
    if ( img->y_omax > img->y_osize ) img->y_omax = img->y_osize;
    if ( img->x_omin < 0 ) img->x_omin = 0;
    if ( img->y_omin < 0 ) img->y_omin = 0;
    if ( img->x_omin >= img->x_osize ) img->x_omin = 0;
    if ( img->y_omin >= img->y_osize ) img->y_omin = 0;
    img->x_tsize = (img->x_omax - img->x_omin);
    if ((img->x_tsize % img->x_obind) != 0) img->x_omax -= (img->x_tsize % img->x_obind);
    img->y_tsize = (img->y_omax - img->y_omin);
    if ((img->y_tsize % img->y_obind) != 0) img->y_omax -= (img->y_tsize % img->y_obind);
    img->tsize =  img->x_tsize * img->y_tsize;
    img->x_size = (img->x_omax + img->x_obind - 1 - img->x_omin) / img->x_obind ;
    img->y_size = (img->y_omax + img->y_obind - 1 - img->y_omin) / img->y_obind ;
    img->size = img->x_size * img->y_size;
    }
/*-----------------------------------------------------------*/
void xy_prtsize( IMAGE *img )
{   prg_printf ("# effective size : (%d-%d)/%d * (%d-%d)/%d => %d * %d = %d\n",
       img->x_omax , img->x_omin, img->x_obind,
       img->y_omax , img->y_omin, img->y_obind,
       img->x_size, img->y_size, img->size);
    }
/*-----------------------------------------------------------*/
void xy_cpsize( IMAGE *img, IMAGE *src )
{   img->x_osize = src->x_osize;
    img->y_osize = src->y_osize;
    img->osize = src->osize;
    img->x_obind = src->x_obind;
    img->y_obind = src->y_obind;
    img->x_omax = src->x_omax;
    img->y_omax = src->y_omax;
    img->x_omin = src->x_omin;
    img->y_omin = src->y_omin;
    img->x_tsize = src->x_tsize;
    img->y_tsize = src->y_tsize;
    img->tsize = src->tsize;
    img->x_size = src->x_size;
    img->y_size = src->y_size;
    img->size = src->size;
    }
/*-----------------------------------------------------------*/
void xy_imgini( IMAGE *img, IMAGE *src )
{   xy_cpsize( img, src);
    img->beg_frame = src->beg_frame;
    img->end_frame = src->end_frame;
    img->cosmic.time = src->cosmic.time;
    img->cosmic.space = src->cosmic.space;
    img->cosmic.s_height = src->cosmic.s_height;
    img->cosmic.t_height = src->cosmic.t_height;
    }
/*-----------------------------------------------------------*/
INT32*   xy16u_bind(IMAGE *img, INT16U *raw)
{   INT32 *val;
    int xbsize, ybsize, xtsize, xbind, ybind;
    int x, xo, xb;
    int y, yo, yb;
    long p, po;
    val = (INT32*) malloc(sizeof(INT32)*img->size);
    if (val == NULL) v_error(__FILE__, " xy16u_bind allocating memory : val %d\n\n", img->size * sizeof(INT32));
    memset( val, 0, sizeof(INT32)*img->size);
    xbsize=img->x_size;
    ybsize=img->y_size;
    xtsize=img->x_tsize;
    xbind=img->x_obind;
    ybind=img->y_obind;
   
    /* if ( xbind == 1 ) */
    for (yo=yb=0; yb<ybsize; yb++, yo+=ybind)
     for (y=0; y<ybind; y++)
      for (xo=xb=0; xb<xbsize; xb++, xo+=xbind)
      {  p=xb+yb*xbsize;
         po=xo+(yo+y)*xtsize;
         for (x=0; x<xbind; x++) val[p]+=raw[po+x];
         }
    img->data = val;
    return val;
    }
/*-----------------------------------------------------------*/
/*  xy16u are always before binding, tsize is the good size  */
double   xy16u_min(IMAGE *img, INT16U  *val)
{   long   i;
    double mini = 0xFFFF;
    for (i=0; i<img->tsize; i++) if( val[i] < mini ) mini = val[i];  
    return mini;
    }
/*-----------------------------------------------------------*/
double   xy16u_max(IMAGE *img, INT16U  *val)
{   long   i;
    double maxi = 0;
    for (i=0; i<img->tsize; i++) if( val[i] > maxi ) maxi = val[i];  
    return maxi;
    }
/*-----------------------------------------------------------*/
double   xy16u_mean(IMAGE *img, INT16U  *val)
{   long   i;
    double mean = 0;
    for (i=0; i<img->tsize; i++) mean += val[i];  
    mean /= img->tsize;
    return mean;
    }
/*-----------------------------------------------------------*/
double   xy16u_sigma(IMAGE *img, INT16U  *val, double mean)
{   double sigma, v;
    long   i;
    sigma=0;
    for (i=0; i<img->tsize; i++) 
    {   v = val[i] - mean;
        sigma  += v * v;
        }
    sigma = sqrt( sigma / (img->tsize -1.0));
    return sigma;
    }
/*-----------------------------------------------------------*/
static int satbind16(IMAGE *img, INT16U *raw, long p, double *r)
{   int xtsize, xbind, ybind;
    int s, x, xo, y, yo;
    long po;
    xtsize=img->x_tsize;
    xbind=img->x_obind;
    ybind=img->y_obind;
   
    s = 0;
	 *r = 0;
	 yo = (p / img->x_size);
	 xo = (p - yo * img->x_size);
    for (y=0; y<ybind; y++)
    {  po=xo*xbind+(yo*ybind+y)*xtsize;
       for (x=0; x<xbind; x++) 
/*{ prg_printf(" p %d xo %d yo %d po %d x %d y %d\n", p, xo, yo, po, x, y);*/
		 if ( raw[po+x] == 0xFFFF) s++;
		 else *r +=raw[po+x];
/*}*/      }
    return s;
    }
/*-----------------------------------------------------------*/
INT32*   xy32_bind(IMAGE *img, INT32 *raw)
{   INT32 *val;
    int xbsize, ybsize, xtsize, xbind, ybind;
    int x, xo, xb;
    int y, yo, yb;
    long p, po;
    val = (INT32*) malloc(sizeof(INT32)*img->size);
    if (val == NULL) v_error(__FILE__, " xy32_bind allocating memory : val %d\n\n", img->size * sizeof(INT32));
    memset( val, 0, sizeof(INT32)*img->size);
    xbsize=img->x_size;
    ybsize=img->y_size;
    xtsize=img->x_tsize;
    xbind=img->x_obind;
    ybind=img->y_obind;
   
    /* if ( xbind == 1 ) */
    for (yo=yb=0; yb<ybsize; yb++, yo+=ybind)
     for (y=0; y<ybind; y++)
      for (xo=xb=0; xb<xbsize; xb++, xo+=xbind)
      {  p=xb+yb*xbsize;
         po=xo+(yo+y)*xtsize;
         for (x=0; x<xbind; x++) val[p]+=raw[po+x];
         }
    img->data = val;
    return val;
    }
/*-----------------------------------------------------------*/
INT32*   xy32f_bind(IMAGE *img, float *raw)
{   INT32 *val;
    int xbsize, ybsize, xtsize, xbind, ybind;
    int x, xo, xb;
    int y, yo, yb;
    long p, po;
    val = (INT32*) malloc(sizeof(INT32)*img->size);
    if (val == NULL) v_error(__FILE__, " xy32f_bind allocating memory : val %d\n\n", img->size * sizeof(INT32));
    memset( val, 0, sizeof(INT32)*img->size);
    xbsize=img->x_size;
    ybsize=img->y_size;
    xtsize=img->x_tsize;
    xbind=img->x_obind;
    ybind=img->y_obind;
   
    /* if ( xbind == 1 ) */
    for (yo=yb=0; yb<ybsize; yb++, yo+=ybind)
     for (y=0; y<ybind; y++)
      for (xo=xb=0; xb<xbsize; xb++, xo+=xbind)
      {  p=xb+yb*xbsize;
         po=xo+(yo+y)*xtsize;
         for (x=0; x<xbind; x++) val[p]+=raw[po+x]+0.5;
         }
    img->data = val;
    return val;
    }
/*-----------------------------------------------------------*/
INT32 xy_valcor(IMAGE *img, int i)
{   if (img->frame[i] == 0 || img->frame[i] == img->used_frames )
       return img->data[i];
	 return 0.5 + (img->data[i]	* img->used_frames) / img->frame[i];
	 }
/*-----------------------------------------------------------*/
void xy_info(IMAGE *img, char cas)
{   long i, xy, v;
    double d, e, m;
    INT32  *val;
    val = img->data;
    if ( cas==0 || cas & 1)
    {   v = 0;
        for (i=0; i<img->size; i++) if( val[i] ) v++;
        img->info.nzero = v;
        }
    if (img->cosmic.sum_corrected == 1)
	 {  if ( cas==0 || cas & 2)
       {  v = val[0];
          xy = 0;
          for (i=1; i<img->size; i++) if( val[i] < v ) { v = val[i]; xy = i;}
          img->info.mini = v;
          img->info.x_min = xy % img->x_size;
          img->info.y_min = xy / img->x_size;
          }
       if ( cas==0 || cas & 4)
       {  v = val[0];
          xy = 0;
          for (i=1; i<img->size; i++) if( val[i] > v ) { v = val[i]; xy =i; }
          img->info.maxi = v;
          img->info.x_max = xy % img->x_size;
          img->info.y_max = xy / img->x_size;
          }
       if ( cas==0 || cas & 8|| cas & 16)
       {  d = 0;
         for (i=0; i<img->size; i++) d += val[i];  
         img->info.mean = m = d / img->size;
         }
       if ( cas==0 || cas & 16)
       {  d = 0;
          for (i=0; i<img->size; i++) 
          {  e = val[i] - m;
             d += e*e; 
             } 
          img->info.sigma = sqrt( d /(img->size-1.0));
          }
		} else  /* cosmic.sum_corrected */
	 {  int used_frames = img->used_frames;
       if ( cas==0 || cas & 2)
       {  v = xy_valcor(img,0);
          xy = 0;
          for (i=1; i<img->size; i++) 
			 if ( xy_valcor(img,i) < v ) { v = xy_valcor(img,i); xy = i;}
          img->info.mini = v;
          img->info.x_min = xy % img->x_size;
          img->info.y_min = xy / img->x_size;
          }
     if ( cas==0 || cas & 4)
     {  v = xy_valcor(img,0);
        xy = 0;
        for (i=1; i<img->size; i++) if( xy_valcor(img,i) > v ) { v = xy_valcor(img,i); xy =i; }
        img->info.maxi = v;
        img->info.x_max = xy % img->x_size;
        img->info.y_max = xy / img->x_size;
        }
     if ( cas==0 || cas & 8|| cas & 16)
     {    d = 0;
         for (i=0; i<img->size; i++) d += xy_valcor(img,i);  
         img->info.mean = m = d / img->size;
        }
     if ( cas==0 || cas & 16)
     {    d = 0;
         for (i=0; i<img->size; i++) 
         {    e = xy_valcor(img,i) - m;
              d += e*e; 
              } 
         img->info.sigma = sqrt( d /(img->size-1.0));
         }
		} 
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
#define EDF_NB 8
int  xy_edfstr  ( XY_HDR *h, char *key, char *content)
{  int pos = h->edf_used;
   if ( pos >= h->edf_disp )  
   {   if ( h->edf_disp == 0 ) h->edf = NULL;
       h->edf= (XY_EDF *) realloc(h->edf, (h->edf_disp+EDF_NB)*sizeof(XY_EDF));
       if (h->edf==NULL) v_error(__FILE__,"allocating edfstr  '%d'\n", pos);
         h->edf_disp+= EDF_NB;
       }
   h->edf[pos].key = malloc( 1+strlen(key));
   if (h->edf[pos].key==NULL) v_error(__FILE__,"allocating edfstr key '%s'\n", key);
   strcpy ( h->edf[pos].key, key);
   h->edf[pos].string = malloc( 1+strlen(content));
   if (h->edf[pos].string==NULL) v_error(__FILE__,"allocating edfstr string '%s'\n", content);
   strcpy ( h->edf[pos].string, content);
   return h->edf_used++;
   }
/*-----------------------------------------------------------*/
void xy_putimg( IMAGE *img, int verbose)
{   if (img->size == 0 ) xy_setsize( img );
    xy_prtsize( img );
    xy_puthdr( img->header, verbose);
    }
/*-----------------------------------------------------------*/
void xy_puthdr( XY_HDR *h, int verbose)
{   int n;
    char *d;
    XY_EDF *p;
    prg_printf( "# file  '%s' : images size %d * %d, frames %d\n", 
           h->name, h->x_dim, h->y_dim, h->frames);
    switch (h->t_data)
    {  case T_FLOAT : d = "FLOAT"; break;
       case T_INT32 : d = "INT32"; break;
       case T_INT16 : d = "INT16"; break;
       case T_INT16U : d = "INT16U"; break;
       case T_ASCII : d = "ASCII"; xy_swapstring = ""; break;
       default : d = "UNKNOWN";
       }
    prg_printf( "# data_type (%s)  %s\n", d, xy_swapstring);
    if (verbose==0) return;
    prg_printf( "# edf header contents :  \n");
    for (n=0, p=h->edf; n < h->edf_used; n++, p++)
       prg_printf( "#%02d# %-15s = %s ; \n", n, p->key, p->string); 
    }
/*-----------------------------------------------------------*/
void xy_fputhdr( FILE *f, XY_HDR *h, int verbose)
{   int n;
    char *d;
    XY_EDF *p;
    fprintf( f, "# file  '%s' : images size %d * %d, frames %d\n", 
           h->name, h->x_dim, h->y_dim, h->frames);
    switch (h->t_data)
    {  case T_FLOAT : d = "FLOAT"; break;
       case T_INT32 : d = "INT32"; break;
       case T_INT16 : d = "INT16"; break;
       case T_INT16U : d = "INT16U"; break;
       default : d = "UNKNOWN";
       }
    fprintf( f, "# data_type (%s)  %s\n", d, xy_swapstring);
    if (verbose==0) return;
    fprintf( f, "# edf header contents :  \n");
    for (n=0, p=h->edf; n < h->edf_used; n++, p++)
       fprintf( f, "#%02d# %-15s = %s ; \n", n, p->key, p->string); 
    }
/*-----------------------------------------------------------*/
void xy_putinfo( IMAGE *img)
{  INFO *inf;
   inf = &(img->info);
   prg_printf( "# %s : %d frame(s), mean %.1lf sigma %.1lf [%ld@%d*%d - %ld@%d*%d] %d!=0\n",
               img->name, img->used_frames, inf->mean, inf->sigma,
               inf->mini, inf->x_min, inf->y_min, inf->maxi, inf->x_max, inf->y_max,
               inf->nzero);
    }
/*-----------------------------------------------------------*/
void xy_fputinfo( FILE *f, IMAGE *img)
{  INFO *inf;
   inf = &(img->info);
   prg_fprintf( f, "# %s : %d frame(s), mean %.1lf sigma %.1lf [%ld@%d*%d - %ld@%d*%d] %d!=0\n",
               img->name, img->used_frames, inf->mean, inf->sigma,
               inf->mini, inf->x_min, inf->y_min, inf->maxi, inf->x_max, inf->y_max,
               inf->nzero);
    }
/*-----------------------------------------------------------*/
int  xy_chkhdr (XY_HDR *h1, XY_HDR *h2)
{    if (h1->x_dim != h2->x_dim ) return -1;
     if (h1->y_dim != h2->y_dim ) return -1;
     return 0;
     }
/*-----------------------------------------------------------*/
void  xy_freehdr (XY_HDR *h)
{    if (h->name) free(h->name);
     if (h->edf)  free(h->edf);
     if (h->file) fclose(h->file);
     free(h);
     }
/*-----------------------------------------------------------*/
void  xy_freeimg ( IMAGE *img, int all)
{   switch (all)
    {  case 3 : 
	     if (img->header) xy_freehdr(img->header);
		  img->header = NULL;
       case 2 : 
        if (img->name ) free(img->name);
        if (img->data) free(img->data);
		  img->name = NULL;
        img->data = NULL;
       case 1 : 
        if (img->frame) free(img->frame);
        img->frame = NULL;
       case 0 : 
        if (img->cosmic.mval) free(img->cosmic.mval);
        if (img->cosmic.mfra) free(img->cosmic.mfra);
        if (img->cosmic.sumq) free(img->cosmic.sumq);
        img->cosmic.mval  = NULL;
        img->cosmic.mfra  = NULL;
        img->cosmic.sumq  = NULL;
        }
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/* lit un fichier et somme les frames */
INT32 *xy_getsum( IMAGE *img, FILE *out, int print, int do_alloc, int do_stat )
{   INT32    *res, *v, *rbind;
    INT16U   *u, *mval, *mfra;
    INT16S   *frame;
	 unsigned char *c;
    float    *f, mf;
    double   vf, *sumq;
    int      l, n, bindcase, ascii_end=0;
    long     i;
    FILE     * print_raw;
    int saturated = 0;
    
    if (img->size == 0 ) 
	 {  xy_setsize( img);
	    if (print) xy_prtsize( img);
		 }
	 bindcase = (img->x_obind > 1) || (img->y_obind > 1);
    if (img->size == 0 ) V_ERROR(" image size is zero in xy_getsum");
    switch (img->header->t_data)
    {   case T_INT16U : u = (INT16U *) prg_alloc( "xy_lib", "u", img->tsize * sizeof(INT16U), 0);
                      break;
        case T_FLOAT : f = (float  *) prg_alloc("xy_lib", "f",  img->tsize * sizeof(float), 0);
                      mf = img->mult;
		       if (mf <= 0.001 ) { img->mult = mf = 1.0; }
		       break;
        case T_INT32 : v = prg_alloc("xy_lib", "v", img->tsize * sizeof(INT32), 0);
		      break;
        case T_CHAR : c = (unsigned char *) prg_alloc( "xy_lib", "c", img->tsize * sizeof(char), 0);
                      break;
        case T_ASCII : v = prg_alloc("xy_lib", "v", img->tsize * sizeof(INT32), 0);
                      break;
        default : v_error("xy_lib", " xy_getsum data type not suppported\n");
       }
    print_raw = (( print & 512 ) && (img->size <= XY_PRINTSIZE )) ? out : NULL ;
    if ( do_alloc )
    {  img->data = res =  (INT32  *) prg_alloc("xy_lib", "img->data",  img->size * sizeof(INT32), 1);
       img->frame = frame = (INT16S  *) prg_alloc("xy_lib", "img->frame",  img->size * sizeof(INT16U), 1);
       if ( do_stat )
       {   img->cosmic.sumq = sumq = (double *) prg_alloc("xy_lib", "cosmic->sumq", img->size * sizeof(double), 1);
           img->cosmic.mval = mval = (INT16U  *) prg_alloc("xy_lib", "cosmic->mval", img->size * sizeof(INT16U), 1);
           img->cosmic.mfra = mfra = (INT16U  *) prg_alloc("xy_lib", "cosmic->mframe", img->size * sizeof(INT16U), 1);
           } else
       {   img->cosmic.sumq = NULL;
           img->cosmic.mval = NULL;
           img->cosmic.mfra = NULL;
           } 
        img->cosmic.saturated = img->cosmic.sum_corrected = 0;
        } 
     else 
     {  res = img->data;
        frame = img->frame;
        sumq = img->cosmic.sumq;
        mval = img->cosmic.mval;
        mfra = img->cosmic.mfra;
        }
    l = n = 0;
    do
    {    if ( ++l < img->beg_frame ) continue;
         if ( img->end_frame != 0 && l > img->end_frame) break;
         if (out && print & 256)  prg_fprintf( out, "# %s : frame %d\n", 
            img->header->name, n+img->beg_frame);
         switch (img->header->t_data)
         {  case T_INT16U : 
             if ( xy_getrawu( img, u, l, print_raw) <= 0 ) continue;
             if ( !bindcase)
				 {  for (i=0; i<img->tsize; i++) if (u[i] == 0xFFFF ) 
                {   u[i]=0;
                    frame[i]-=1;
                    saturated +=1;
                    }
                for (i=0; i<img->size; i++) res[i] += u[i];
                if ( do_stat ) for (i=0; i<img->size; i++)
                {  vf = u[i];
                   sumq[i] += vf*vf;
                   if (u[i]>mval[i]) { mval[i]=u[i]; mfra[i]=n; }
                   }
				    }
				 else for (i=0; i<img->size; i++)
				 {  if ( satbind16(img, u, i, &vf) )
					 {  frame[i]-=1;
                   saturated +=1;
                   }
                else
					 {  res[i] += vf;
                   if ( do_stat )
                   {  sumq[i] += vf*vf;
                      if (vf>mval[i]) { mval[i]=vf; mfra[i]=n; }
                      }
						 }
				    } 	 
             break;
            case T_INT32 :          
             if ( xy_getrawl( img, v, l, print_raw) <= 0 ) continue;
             if ( !bindcase)
             {  for (i=0; i<img->size; i++) res[i] += v[i];
                if ( do_stat ) for (i=0; i<img->size; i++) 
                {   vf = v[i];
                    sumq[i] += vf*vf;
                    if (v[i]>mval[i]) {mval[i]=v[i]; mfra[i]=n+img->used_frames; }
                    }
					 } else {
                rbind = xy32_bind(img, v);
                for (i=0; i<img->size; i++) res[i] += rbind[i];
                if ( do_stat ) for (i=0; i<img->size; i++) 
                {   vf = rbind[i];
                    sumq[i] += vf*vf;
                    if (v[i]>mval[i]) {mval[i]=v[i]; mfra[i]=n+img->used_frames; }
                    }
					 free (rbind);	  
					 }	 	  
             break;
           case T_CHAR : 
             if ( xy_getrawc( img, c, l, print_raw) <= 0 ) continue;
             if ( !bindcase)
             {   for (i=0; i<img->size; i++) res[i] += c[i];
                 if ( do_stat ) for (i=0; i<img->size; i++)
                 {   vf = c[i];
                     sumq[i] += vf*vf;
                     if (c[i]>mval[i]) { mval[i]=c[i]; mfra[i]=n; }
                     }
					   } v_error(__FILE__,"binding not writen for char files\n");
             break;
            case T_FLOAT :          
             if ( xy_getrawf( img, f, l, print_raw) <= 0 ) continue;
             if ( !bindcase)
             {   for (i=0; i<img->size; i++) 
                 {  INT16U d;
                    res[i] += d = mf*(f[i]+0.5);
                    if ( do_stat ) 
                    {   vf = d;
                        sumq[i] += vf*vf;
                        if (d>mval[i]) mval[i]=d;
                        }
                     }
						} else {
                rbind = xy32f_bind(img, f);
                for (i=0; i<img->size; i++) res[i] += rbind[i];
                if ( do_stat ) for (i=0; i<img->size; i++) 
                {   vf = rbind[i];
                    sumq[i] += vf*vf;
                    if (v[i]>mval[i]) {mval[i]=v[i]; mfra[i]=n+img->used_frames; }
                    }
					 free (rbind);	  
					 }	 	  
             break;
            case T_ASCII :          
             if ( xy_getrawa( img, v, l, print_raw) <= 0 ) { ascii_end = 1; continue; }
             printf (" n %d l %d ascii %d\n", n, l, ascii_end);
				 if ( !bindcase)
             {  for (i=0; i<img->size; i++) res[i] += v[i];
                if ( do_stat ) for (i=0; i<img->size; i++) 
                {   vf = v[i];
                    sumq[i] += vf*vf;
                    if (v[i]>mval[i]) {mval[i]=v[i]; mfra[i]=n+img->used_frames; }
                    }
					 } else {
                rbind = xy32_bind(img, v);
                for (i=0; i<img->size; i++) res[i] += rbind[i];
                if ( do_stat ) for (i=0; i<img->size; i++) 
                {   vf = rbind[i];
                    sumq[i] += vf*vf;
                    if (v[i]>mval[i]) {mval[i]=v[i]; mfra[i]=n+img->used_frames; }
                    }
					 free (rbind);	  
					 }	 	  
             }  /* switch */
         n++;
         } while ( !feof( img->header->file) && ascii_end == 0 );
    if ( n == 0 )
        v_error( __FILE__, "no data found in file between frames %d and %d\n",
            img->beg_frame, img->end_frame);
    if ( do_alloc ) img->used_frames = n;
	 else  img->used_frames += n;
    if ( out && print & 4 )
        prg_fprintf( out, "# %s : %d frames used\n", img->header->name, n);
    for (i=0; i <img->size; i++)  frame[i] += n;
    switch (img->header->t_data)
    {  case T_INT16U :
        img->cosmic.saturated += saturated;
        if ( out && print & 4 )
        prg_fprintf( out, "# %d saturated pixels found\n", saturated);
                      free(u); break;
       case T_INT32 : free(v); break;
       case T_CHAR  : free(c); break;
       case T_FLOAT : free(f); break;
       case T_ASCII : free(v); break;
       }
    img->t_data = T_INT32;
    img->data = res;
	 return res;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
int xy_tcosmic( IMAGE *img, FILE *out )
{   double sigc, sig2, mean, meanc, fn, fs, fc, zz, h, d, e, r;
    int i;
    int n_cosmic = 0;
	 double mvald;
    int size = img->size;
    int x_size = img->x_size;
    INT16U *mval = img->cosmic.mval;
    INT16U *mfra = img->cosmic.mfra;
    INT16S *frame = img->frame;
    INT32  *res  = img->data;
    double *res2 = img->cosmic.sumq; /* float leads to error on sigc (neg val) */
        
    zz = img->cosmic.time * img->cosmic.time;
    h = img->cosmic.t_height;
    r = img->cosmic.ratio;
    for (i=0; i<size; i++) if ((fn = frame[i]) >= 3)
    {   fs = fn-1;
        fc = fn-2;
        mean = res[i] / fn;
        sig2 = (res2[i] - fn*mean*mean ) / fs;
        d = mval[i];
        meanc = (res[i]-d) / fs;
        sigc = (res2[i]-d*d - fs*meanc*meanc ) / fc;
        e = d-meanc;
        if ( e*e > zz * sigc && sigc*r < sig2 && e > h)
        {  n_cosmic++;
  if (out) fprintf(out, "#cosmic %4d %4d (%2d): %5d  <m> %8.1lf s %7.1lf ---> <m> %8.1lf s %6.1lf\n",
  i%x_size, i/x_size, mfra[i], mval[i], mean, sqrt(sig2+0.01), meanc, sqrt(sigc+0.01)); 
           res[i] -= mval[i];
           mvald = mval[i];
			  res2[i] -= mvald*mvald;
           frame[i] -=1;
           }
       }
  img->cosmic.t_number = n_cosmic;     
    return  n_cosmic;
    }
/*-----------------------------------------------------------*/
double xy_vmean( IMAGE *img, int i, int xi, int xf, int yi, int yf, int *n, double *sig2)
{   int x, y, ii, xx, yy, sumn;
    double w, s2, mean, rho;
    x= i % img->x_size;
    y= i / img->x_size;
    mean = s2 =0;
    sumn = 0;
    for ( yy=y+yi; yy<=y+yf; yy++)
    if (yy>=0 && yy<img->y_size)
    for ( xx=x+xi; xx<=x+xf; xx++)
    if (xx>=0 && xx<img->x_size)
    {  ii = xx + yy * img->x_size;
       if ( img->frame[ii] )
		 {   w = xy_valcor(img, ii);
           mean += w;
           s2 += w*w;
           sumn += 1;
           } 
      }    
    *n = sumn;
    if (sumn == 0 ) return 0;
    mean /= sumn;
    if (sig2 != NULL && sumn > 1 ) 
    {  s2 -= sumn*mean*mean;
       *sig2 = s2/(sumn-1);
       }
    return mean;
    }
/*-----------------------------------------------------------*/
int xy_space( IMAGE *img, FILE *out )
{   double v, mean, sig2, meanc, sigc, zz, h, e, r;
    INT16S *frame = img->frame;
    INT32  *res  = img->data;
	 unsigned char   *ncor;
    int new, step;
	 int i, j, sumn, sumnc, n_cosmic = 0;
    int size = img->size;
/*  double sumq; */
    
    ncor = (unsigned char *) malloc(size);
    memset(ncor, 0, size);
	 zz = img->cosmic.space * img->cosmic.space;
    h = img->cosmic.s_height;
    r = img->cosmic.ratio;
    for (step=0; step < 10; step++)
	 {   new = 0;
	 for (i=j=0; j<size; j++, i++) 
    {   mean = xy_vmean( img, i, -1, 1, -1, 1, &sumn, &sig2);
        if ( sumn <= 2 ) continue;
        v = res[i];
        if (frame[i] != 0 )
		  {  meanc = (mean*sumn-v) / (sumn-1);
           sigc = (sig2*(sumn-1)+sumn*mean*mean-v*v-(sumn-1)*meanc*meanc)/(sumn-2);
			  sumnc = sumn-1;
           e = v-meanc;
           if ( e*e > zz*sigc && sigc*r < sig2 && e > h) 
           {  if (ncor[i] == 0)
              {  new++;
			        n_cosmic++;
				     }
  if (out) fprintf(out, "#space %4d %4d : %6d (%d <m> %8.1lf s %7.1lf ---> %d <m> %8.1lf s %6.1lf)  n=%d\n",
  i%img->x_size, i/img->x_size, res[i], sumn, mean, sqrt(sig2+0.01), sumnc, meanc, sqrt(sigc+0.01), ncor[i]); 
              res[i] = meanc;
              frame[i] = 0;
			     ncor[i]+=1;
			     }
			  } else
		  {  meanc = mean;
           sigc = sig2;
			  sumnc = sumn;
           e = v-meanc;
           if ( frame[i] == 0 && e >= 1 )
           {  if (ncor[i] == 0)
              {  new++;
			        n_cosmic++;
				     }
  if (out) fprintf(out, "#space %4d %4d : %6d (                         ---> %d <m> %8.1lf s %6.1lf)  n=%d\n",
  i%img->x_size, i/img->x_size, res[i], sumnc, meanc, sqrt(sigc+0.01), ncor[i]); 
               res[i] = meanc;
              frame[i] = 0;
			     ncor[i]+=1;
			     }
			  }
       } /* for i */
		    if (new == 0) break;
		 }
    img->cosmic.s_number = n_cosmic;    
	 free(ncor); 
    return  n_cosmic;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
void xy_val_dump( IMAGE * img, FILE * out, char * hdr)
{  int i, j, k;
   INT32 * val = img->data;
   for (j=0; j < img->y_size; j++)
   {   if (hdr) prg_fprintf( out, "%2s %3d :", hdr, j);
       for (i=0, k=j*img->x_size; i < img->x_size; i++, k++) 
           prg_fprintf( out, " %d", val[k]);
       prg_fprintf( out, "\n");
       }
   }
/*-----------------------------------------------------------*/
void xy_sum_dump( IMAGE * img, FILE * out, char * hdr)
{  int i, j, k;
   INT32 * val = img->data;
   INT16S * frame = img->frame;
   for (j=0; j < img->y_size; j++)
   {   prg_fprintf( out, "%s %3d :", hdr, j);
       for (i=0, k=j*img->x_size; i < img->x_size; i++, k++) 
           prg_fprintf( out, " %7d(%2d)", val[k], frame[k]);
       prg_fprintf( out, "\n");
       }
   prg_fflush(out);
	}
/*-----------------------------------------------------------*/
void xy_sta_dump( IMAGE * img, FILE * out, char * hdr)
{  int i, j, k;
   double m, t,tu;
   INT32 * val = img->data;
   INT16S * frame = img->frame;
   double * sumq = img->cosmic.sumq;
	double sig2;
   /* s */
	tu = img->used_frames;
   for (j=0; j < img->y_size; j++)
   {  prg_fprintf( out, "%5s   %3d :", hdr, j);
      for (i=0, k=j*img->x_size; i < img->x_size; i++, k++) 
      {   t = frame[k];
          m = img->cosmic.sum_corrected ? val[k]/tu : val[k]/t;
          prg_fprintf( out, " %8.1f", m);
          if (sumq)
			 {  sig2 =sumq[k] -t*m*m;
			    if ( sig2 > 0 && t > 1) prg_fprintf( out, "(%5.1lf)", sqrt( sig2/ (t-1.0)));
             else prg_fprintf( out, "( *** )");
				 }
          else prg_fprintf( out, "(     )");
          }
       prg_fprintf( out, "\n");
       }
   prg_fflush(out);
    }   
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
int xy_getrawc(IMAGE *img, unsigned char *val, int pos, FILE *out )
{   int  i, j, k, xread, xseek, xfor, yfor, size;
    long   p;
    unsigned char   *vu;
    FILE *file = img->header->file;
    size = sizeof(char);
    p = img->header->header_end + sizeof(char) * ( (pos-1) * img->osize
           + img->y_omin * img->x_osize + img->x_omin );
   xread=size*img->x_tsize;
   xseek=size*img->x_osize;
   xfor=img->x_tsize;
   yfor=img->y_tsize;
   for ( k=0; k<yfor; k++, p+=xseek )
   {   fseek( file, p, 0);
       vu = (unsigned char *) val + k * xfor;
       if ( (j=fread( (unsigned char *) vu, xread, 1, file)) != 1 )
       if ( k == 0 )  return 0;
       else
       {   fprintf(stderr, "xy_getrawc error %d reading %d image at y = %d, y_min %d, pos %d\n",
                  errno, j, k+img->y_omin, img->y_omin, pos);
           return -1;
           }
       if (out)
       {   prg_fprintf( out, "#I %3d :", k);
           for (i=0; i < xfor; i++) prg_fprintf( out, " %5d", *(vu+i));
           prg_fprintf( out, "\n");
           }
       }
   return img->y_tsize;
   }
/*-----------------------------------------------------------*/
int xy_getrawu(IMAGE *img, INT16U *val, int pos, FILE *out )
{   int  i, j, k, xread, xseek, xfor, yfor, size;
    long   p;
    INT16U   *vu;
    FILE *file = img->header->file;
    size = sizeof(INT16U);
    p = img->header->header_end + sizeof(INT16U) * ( (pos-1) * img->osize
           + img->y_omin * img->x_osize + img->x_omin );
   xread=size*img->x_tsize;
   xseek=size*img->x_osize;
   xfor=img->x_tsize;
   yfor=img->y_tsize;
   for ( k=0; k<yfor; k++, p+=xseek )
   {   fseek( file, p, 0);
       vu = (INT16U *) val + k * xfor;
       if ( (j=fread( (char *) vu, xread, 1, file)) != 1 )
       if ( k == 0 )  return 0;
       else
       {   fprintf(stderr, "xy_getrawu error %d reading %d image at y = %d, y_min %d, pos %d\n",
                  errno, j, k+img->y_omin, img->y_omin, pos);
           return -1;
           }
       if (xy_doswap)
        for (i=0; i < xfor; i++) xy_eswap16 (vu+i);
       if (out)
       {   prg_fprintf( out, "#I %3d :", k);
           for (i=0; i < xfor; i++) prg_fprintf( out, " %5d", *(vu+i));
           prg_fprintf( out, "\n");
           }
       }
   return img->y_tsize;
   }
/*-----------------------------------------------------------*/
int xy_getrawl(IMAGE *img, INT32 *val, int pos, FILE *out)
{   int  i, j, k, xread, xseek, xfor, yfor, size;
    long   p;
    FILE *file = img->header->file;
    INT32    *vl;
    size = sizeof(INT32);
   p = img->header->header_end + size * ( (pos-1) * img->osize
           + img->y_omin * img->x_osize + img->x_omin );
   xread=size*img->x_tsize;
   xseek=size*img->x_osize;
   xfor=img->x_tsize;
   yfor=img->y_tsize;
   for ( k=0; k<yfor; k++, p+=xseek )
   {   fseek( file, p, 0);
       vl = (INT32 *) val + k * xfor;
       if ( (j=fread( (char *) vl, xread, 1, file)) != 1 )
       if ( k == 0 )  return 0;
       else
       {   fprintf(stderr, "xy_getrawl error %d reading %d image at y = %d, y_min %d, pos %d\n",
                  errno, j, k+img->y_omin, img->y_omin, pos);
           return -1;
           }
       if (xy_doswap)
        for (i=0; i < xfor; i++) xy_eswap32 (vl+i);
       if (out)
       {   prg_fprintf( out, "#I %3d :", k);
           for (i=0; i < xfor; i++) prg_fprintf( out, " %5d", *(vl+i));
           prg_fprintf( out, "\n");
           }
       }
   return img->y_tsize;    
   }
/*-----------------------------------------------------------*/
int xy_getrawf(IMAGE *img, float *val, int pos, FILE *out)
{   int  i, j, k, xread, xseek, xfor, yfor, size;
    long   p;
    float    *vf;
    FILE *file = img->header->file;
    size = sizeof(float);
   p = img->header->header_end + size * ( (pos-1) * img->osize
           + img->y_omin * img->x_osize + img->x_omin );
   xread=size*img->x_tsize;
   xseek=size*img->x_osize;
   xfor=img->x_tsize;
   yfor=img->y_tsize;
   for ( k=0; k<yfor; k++, p+=xseek )
   {   fseek( file, p, 0);
        vf = (float *) val + k * xfor;
       if ( (j=fread( (char *) vf, xread, 1, file)) != 1 )
       if ( k == 0 )  return 0;
       else
       {   fprintf(stderr, "xy_getrawf error %d reading %d image at y = %d, y_min %d, pos %d\n",
                  errno, j, k+img->y_omin, img->y_omin, pos);
           return -1;
           }
       if (xy_doswap)
        for (i=0; i < xfor; i++) xy_eswap32 ((INT32 *) (vf+i));
       if (out)
       {  prg_fprintf( out, "#I %3d :", k);
          for (i=0; i < xfor; i++) prg_fprintf( out, " %5f", *(vf+i));
          prg_fprintf( out, "\n");
          }
       }
   return img->y_tsize;    
   }
/*-----------------------------------------------------------*/
int xy_getrawa(IMAGE *img, INT32 *val, int pos, FILE *out)
{   int  ix, iy, jx, jy, xfor, yfor, ip;
    long   p, v;
    FILE *file = img->header->file;
    INT32    *vl;
    p = img->header->header_end;
	 xfor=img->x_tsize;
    yfor=img->y_tsize;
	 if ( pos == 1) fseek( file, p, 0);
	 if ( pos != 1) 
#define BUF_LG 4096
	 {  char buffer[BUF_LG+1];
	    for (ip=1; ip <pos; ip++)
		 {  for (iy = 0; iy <img->header->y_dim; iy++ ) fgets(buffer, BUF_LG, file);
		    buffer[0]=0;
			 fgets(buffer, BUF_LG, file);
			 if (buffer[0] != '#')
			 {  printf("xy_getrawa pos %d : multiframe txt image with more than one '#' line\n%s\n", 
			         pos, buffer);
	           fseek( file, 0, 1); fscanf( file, "%d", &v); /* to the end of file */
		        return -1;
			 }	  }
		 }
	 if (feof(file)) return 0;
	 for ( iy=0; iy<img->header->y_dim; iy++ )
	 {  jy = iy - img->y_omin;
       vl = val + jy * xfor;
       for ( ix=0; ix<img->header->x_dim; ix++ )
	    {  if ( fscanf(file,"%d", &v) == 1) 
		    {  if ( jy >= 0 && jy < yfor )
			    {  jx = ix - img->x_omin;
			       if ( jx >= 0 && jx < xfor)
				    {	  vl[jx] = v;
		              }
				    }
		       }
		    else
		    {  fprintf(stderr, "xy_getrawa error %d reading image %d at y = %d/%d, x = %d/%d\n",
                  errno, pos, iy, img->header->y_dim, ix, img->header->x_dim);
             return -1;
		       }
			 }
/*     printf( "#I %3d :", jy);
           for (jx=0; jx < xfor; jx++) printf( " %5d", *(vl+jx));
           printf( "\n");
*/
      if (out)
     {   prg_fprintf( out, "#I %3d :", jy);
           for (jx=0; jx < xfor; jx++) prg_fprintf( out, " %5d", *(vl+jx));
           prg_fprintf( out, "\n");
           }
        }
	printf(" txt frame %d read\n", pos);
	/* fseek( file, 0, 1);  fscanf( file, "%d", &v); /* to the end of file, avoids warning */
   return img->y_tsize;    
   }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/* swap functions : used through indirect call               */
/*-----------------------------------------------------------*/
void xy_setswapon(void)
{   xy_swap16 = xy_eswap16;
    xy_swap32 = xy_eswap32;
    xy_doswap=-1;
    xy_swapstring = "swapping used";
    }
void xy_setswapoff(void)
{   xy_swap16 = xy_nswap16;
    xy_swap32 = xy_nswap32;
    xy_doswap = 0;
    xy_swapstring = "no swapping used";
    }
/*-----------------------------------------------------------*/
/*   fseek, fread and swap if necessary                      */
/*-----------------------------------------------------------*/
int  xy_fread16( INT16U* val, long seek, FILE *f)
{   int i;
    fseek(f, seek, 0);
    i = fread(val, sizeof(INT16U), 1, f);
    xy_swap16(val);
    return i;
    }
int  xy_fread32( INT32* val, long seek, FILE *f)
{   int i;
    fseek(f, seek, 0);
    i = fread( val, sizeof(INT32), 1, f);
    xy_swap32(val);
    return i;
    }
/* --------------------------------------------------------- */
/* static functions used for swapping if necessary           */
/*-----------------------------------------------------------*/
void xy_eswap16(INT16U * brut)
{   unsigned char c;
    SWAP16 *s;
    s = (SWAP16 *) brut;
    c = s->c.h;
    s->c.h = s->c.l;
    s->c.l = c;
      }
#pragma argsused
void xy_nswap16(INT16U * brut) /* do nothing but can be called */
{   }
void xy_eswap32(INT32 * brut)
{   INT16U t;
    SWAP32 *s;
    s = (SWAP32 *) brut;
    t = s->u[0];
    s->u[0] = s->u[1];
    s->u[1] = t;
    xy_eswap16(&s->u[0]);
    xy_eswap16(&s->u[1]);
    }
#pragma argsused
void xy_nswap32(INT32 * brut)  /* do nothing but can be called */
{   }
/* ------------------------------------------------------- */
/*-----------------------------------------------------------*/
/* split name for multi file frames et rebuild it */
int xy_rep_name(char *name, IMAGE *img, char *bname, char *ename, 
          int *df, int *iname, int *dont_cor, int *used_frames,
			 ADD_MERGE *rep_mode)   
{  char *c, *d, *e;
   int repeat = 1;
   *rep_mode = ADD_IMG;
	*iname = *dont_cor = *used_frames = *df =0;
	strcpy(bname, name);
   c = strchr (bname, ',');
   if ( c )
   {  *c=0;
       d = c+1;
       while (strlen(d))
       { e = strchr (d, ',');
         if (e) *e = 0;
         switch (*d)
         {  case 'B' : img->beg_frame= atoi(d+1);  break;
            case 'E' : img->end_frame= atoi(d+1);  break;
            case 'X' : *dont_cor = 1;  break;
            case 'U' : *used_frames= atoi(d+1);  break;
            case 'M' : *rep_mode = MERGE_IMG;
            case 'A' : if ( repeat != 1) V_ERROR("invalid file option : A or M");
                       repeat = atoi(d+1);  break;
            default : v_error(__FILE__, "invalid file option '%s' in '%s' ", d, bname);
            }
         if (e) d = e + 1; else d+= strlen(d);
         }
     }
  c = strrchr(bname, '.');
   if ( c )
   {   strcpy(ename, c);
       *c = 0;
       }
   else ename[0]=0;
   c = bname + strlen(bname) - 1;
   while ( isdigit(*c) ) { c--; (*df)++; }
   c++;
   if ( isdigit(*c) )
   {   *iname = atoi(c);
       *c = 0;
       }
  return repeat;
  }
/*-----------------------------------------------------------*/
int xy_cur_name(char *buffer, char *path, 
        char *bname, char *ename, int df, int iname)   
{  char cname[200];
   if (df) sprintf(cname, "%s%0*d%s", bname, df, iname, ename);
   else   sprintf(cname, "%s%s", bname, ename);
   if (path && path[0] && bname[0]!=PATH_CHAR && bname[0]!='.')
   {    strcpy( buffer, path);
        if (buffer[strlen(buffer)-1] != PATH_CHAR ) strcat(buffer,PATH_STR );
        } else buffer[0]=0;
	 strcat (buffer, cname );
	 }
/* ------------------------------------------------------- */
XY_HDR * xy_open(char *name, char *msg, int quick, char *ext, int real_time, int try_identify)
{  struct stat statbuf;   /*  header pbs with stat_buf */
   char buffer[250];  
   char full_name[200];
	char *c, *d;  
	time_t tloc, dt;           
	if (real_time)
	{  c = strcpy(full_name, name);
      d = c + strlen(c) -4;
	   if ( *d != '.') strcat(full_name, ext);
	   while ( stat(full_name, &statbuf) != 0) 
		{  printf(" file %s not stated, waiting %d seconds\n", full_name, real_time);
			sleep(real_time);
			}
      time( &tloc);
		dt = tloc - statbuf.st_mtime;
		printf(" file %s stated, last modification is %d seconds old\n", full_name, dt);
		if ( dt < real_time)
		{  printf(" waiting %d seconds to ensure data completion\n", real_time - dt);
		   sleep(real_time - dt);
		   }
		}
   c = name;
   d = c + strlen(c) -4;
#if (defined(DEF_XY_WV) || defined(INC_XY_WV))
   if ( strstr(c, ".spe") == d ) return wv_open (c, msg, quick);
   if ( strstr(c, ".SPE") == d ) return wv_open (c, msg, quick);
#endif
#if (defined(DEF_XY_EDF) || defined(INC_XY_EDF))
   if ( strstr(c, ".edf") == d ) return edf_open (c, msg, quick);
#endif
#if (defined(DEF_XY_TXT) || defined(INC_XY_TXT))
   if ( strstr(c, ".txt") == d ) return txt_open (c, msg, quick);
#endif
#if (defined(DEF_XY_GEL) || defined(INC_XY_GEL))
   if ( strstr(c, ".gel") == d || strstr(c, ".tif") == d) return gel_open (c, msg, quick);
#endif
	if (try_identify)
	{   FILE * chk;
	    buffer[0] = 0;
		 chk = fopen(buffer, "rb");
       if ( chk )
       {  fread(buffer, 1, 80, chk);
          fclose (chk );
#if (defined(DEF_XY_GEL) || defined(INC_XY_GEL))
          if ( (buffer[0] == 'M' && buffer[1] == 'M') || (buffer[0] == 'I' && buffer[1] == 'I'))
			        return gel_open (c, msg, quick);
#endif
#if (defined(DEF_XY_EDF) || defined(INC_XY_EDF))
          if (buffer[0] == '{' && buffer[1] == 0x0a ) return edf_open (c, msg, quick);
#endif
#if (defined(DEF_XY_DMI) || defined(INC_XY_DMI))
          if (strstr(buffer," CARTE HPC1-SEP") == buffer ) return dmi_open (c, msg, quick);
#endif
       }  }
#if (defined(DEF_XY_GEL) || defined(INC_XY_GEL))
   if (strstr(ext , "gel")) return gel_open (c, msg, quick); 
#endif
#if (defined(DEF_XY_EDF) || defined(INC_XY_EDF))
   if (strstr(ext , "edf"))  return edf_open (c, msg, quick); 
#endif
#if (defined(DEF_XY_TXT) || defined(INC_XY_TXT))
   if (strstr(ext , "txt"))  return txt_open (c, msg, quick); 
#endif
#if (defined(DEF_XY_WV) || defined(INC_XY_WV))
   if (strstr(ext , "spe"))  return wv_open (c, msg, quick); 
   return wv_open (c, msg, quick); 
#else
   v_error(__FILE__, "xy_open unexpected case : symbol definition in make???");
   return NULL;
#endif
   }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/

